'use strict';

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var _require = require('chai');

const expect = _require.expect;


describe('error-handler', () => {
  it('should return global error code in common middleware', _asyncToGenerator(function* () {
    var _ref2 = yield api.get('/exception').expect(400);

    const body = _ref2.body;

    expect(body.name).to.eql('BadRequest');
  }));

  it('should return local error code inside handler', _asyncToGenerator(function* () {
    var _ref4 = yield api.get('/exception').query({ message: 'BadRequest' }).expect(400);

    const body = _ref4.body;

    expect(body.name).to.eql('/exception.get.BadRequest');
  }));

  it('should return local only error code', _asyncToGenerator(function* () {
    var _ref6 = yield api.get('/exception').query({ message: 'UnknownException' }).expect(500);

    const body = _ref6.body;

    expect(body.name).to.eql('/exception.get.UnknownException');
  }));

  it('should return normal error code if x-errors not exist', _asyncToGenerator(function* () {
    var _ref8 = yield api.delete('/exception').expect(400);

    const body = _ref8.body;

    expect(body.name).to.eql('BadRequest');
  }));
});