'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

const parseUrl = require('url').parse;

const _ = require('lodash');

var _require = require('json-refs');

const resolve = _require.resolveRefs;


const Path = require('./path');
const parseAsync = require('./parse');
const validateAsync = require('./definition-validator');

let Swagger = function () {
  _createClass(Swagger, null, [{
    key: 'createAsync',
    value: (() => {
      var _ref = _asyncToGenerator(function* (dynamicDefinition) {
        const definition = yield parseAsync({ dynamicDefinition });
        yield validateAsync(definition);
        const definitionResolved = (yield resolve(definition)).resolved;
        return new Swagger(definitionResolved);
      });

      function createAsync(_x) {
        return _ref.apply(this, arguments);
      }

      return createAsync;
    })()
  }]);

  function Swagger(definition) {
    _classCallCheck(this, Swagger);

    this.definition = definition;
    _.assign(this, definition);

    let basePathPrefix = definition.basePath || '/';
    // Remove trailing slash from the basePathPrefix so we do not end up with double slashes
    if (basePathPrefix.charAt(basePathPrefix.length - 1) === '/') {
      basePathPrefix = basePathPrefix.substring(0, basePathPrefix.length - 1);
    }
    this.basePathPrefix = basePathPrefix;

    this.pathObjects = _.map(definition.paths, (pathDef, path) => {
      return new Path(path, pathDef, this, ['paths', path]);
    });
  }

  _createClass(Swagger, [{
    key: 'getPath',
    value: function getPath(url) {
      return _.find(this.pathObjects, pathObject => {
        return _.isArray(pathObject.regexp.exec(url));
      });
    }
  }, {
    key: 'getOperation',
    value: function getOperation(req) {
      const url = parseUrl(req.url).pathname;
      const method = req.method;

      const path = this.getPath(url);
      if (!path) {
        return undefined;
      }

      return path.getOperation(method);
    }
  }]);

  return Swagger;
}();

exports.Swagger = Swagger;
exports.parseAsync = parseAsync;