'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

const pathToRegexp = require('path-to-regexp');
const _ = require('lodash');

const Operation = require('./operation');

let Path = function () {
  function Path(path, definition, parent, pathToDefinition) {
    _classCallCheck(this, Path);

    this.path = path;
    this.definition = definition;
    this.parent = parent;
    this.pathToDefinition = pathToDefinition;
    this.regexp = pathToRegexp(parent.basePathPrefix + path.replace(/\{/g, ':').replace(/\}/g, ''));

    this.operationObjects = _.map(definition, (operationDef, method) => {
      return new Operation(method, operationDef, this, pathToDefinition.concat(method));
    });
  }

  _createClass(Path, [{
    key: 'getOperation',
    value: function getOperation(method) {
      method = method.toLowerCase();
      let getOperationObject;
      let object = _.find(this.operationObjects, operationObject => {
        if (operationObject.method === 'get') {
          getOperationObject = operationObject;
        }
        if (operationObject.method === method) {
          return operationObject;
        }
      });
      if (!object && getOperationObject) {
        object = getOperationObject;
      }
      return object;
    }
  }]);

  return Path;
}();

module.exports = Path;